package org.vtokarev.controller;

import org.vtokarev.domain.User;
import org.vtokarev.domain.UserRole;
import org.vtokarev.dto.RoomRequestDto;
import org.vtokarev.service.RoomRequestService;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

/**
 * The {@code RequestListServlet} class processes GET {@code requestList} requests generated by users with GUEST and MANAGER roles.
 * Gets {@link List<RoomRequestDto>} set it as an attribute and forward the control to {@code requestList.jsp} view for further processing.
 *
 * @author Vyacheslav Tokarev
 */


@WebServlet(urlPatterns = "/requestList", name = "requestListServlet")
public class RequestListServlet extends HttpServlet {

    RoomRequestService roomRequestService;

    @Override
    public void init(ServletConfig config) throws ServletException {
        roomRequestService = (RoomRequestService)config.getServletContext().getAttribute("app/RoomRequestService");
    }

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        User user = (User)req.getSession().getAttribute("user");
        List<RoomRequestDto> roomRequests = null;

        if(user.getUserRole() == UserRole.GUEST)
            roomRequests = roomRequestService.getRequestsByUserId(user.getId());
        else if (user.getUserRole() == UserRole.MANAGER) {
            roomRequests = roomRequestService.getRequestsByUserId(null);
        }

        req.setAttribute("roomRequests", roomRequests);
        req.getRequestDispatcher("/WEB-INF/jsp/requestList.jsp").forward(req, resp);
    }
}